package jaredbgreat.dldungeons.themes;


/*This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/	


import java.util.ArrayList;
import java.util.HashSet;
import java.util.Random;

import net.minecraft.world.biome.BiomeGenBase;
import net.minecraftforge.common.BiomeDictionary;
import net.minecraftforge.common.BiomeDictionary.Type;

public class BiomeLists {

	
	static HashSet<Theme> forest    = new HashSet<Theme>();
	static HashSet<Theme> plains    = new HashSet<Theme>();
	static HashSet<Theme> mountain  = new HashSet<Theme>();
	static HashSet<Theme> hills     = new HashSet<Theme>();
	static HashSet<Theme> swamp     = new HashSet<Theme>();
	static HashSet<Theme> water     = new HashSet<Theme>();
	static HashSet<Theme> desert    = new HashSet<Theme>();
	static HashSet<Theme> frozen    = new HashSet<Theme>();
	static HashSet<Theme> jungle    = new HashSet<Theme>();
	static HashSet<Theme> wasteland = new HashSet<Theme>();
	static HashSet<Theme> nether    = new HashSet<Theme>();
	static HashSet<Theme> end       = new HashSet<Theme>();
	static HashSet<Theme> mushroom  = new HashSet<Theme>();
	static HashSet<Theme> magical   = new HashSet<Theme>();
    
    
    public static void registerTheme(Theme theme) {
		if(theme.biomes.contains(Type.END))       {
			end.add(theme);
			System.out.println("[DLDUNGEONS] Assigning theme " + theme + " to end.");
		}
		if(theme.biomes.contains(Type.DESERT))    {
			desert.add(theme);
			System.out.println("[DLDUNGEONS] Assigning theme " + theme + " to desert.");
		}
		if(theme.biomes.contains(Type.FOREST))    {
			forest.add(theme);
			System.out.println("[DLDUNGEONS] Assigning theme " + theme + " to forest.");
		}
		if(theme.biomes.contains(Type.FROZEN))    {
			frozen.add(theme);
			System.out.println("[DLDUNGEONS] Assigning theme " + theme + " to frozen.");
		}
		if(theme.biomes.contains(Type.HILLS))     {
			hills.add(theme);
			System.out.println("[DLDUNGEONS] Assigning theme " + theme + " to hills.");
		}
		if(theme.biomes.contains(Type.JUNGLE))    {
			jungle.add(theme);
			System.out.println("[DLDUNGEONS] Assigning theme " + theme + " to jungle.");
		}
		if(theme.biomes.contains(Type.MAGICAL))   {
			magical.add(theme);
			System.out.println("[DLDUNGEONS] Assigning theme " + theme + " to magical.");
		}
		if(theme.biomes.contains(Type.MOUNTAIN))  {
			mountain.add(theme);
			System.out.println("[DLDUNGEONS] Assigning theme " + theme + " to mountain.");
		}
		if(theme.biomes.contains(Type.MUSHROOM))  {
			mushroom.add(theme);
			System.out.println("[DLDUNGEONS] Assigning theme " + theme + " to mushroom.");
		}
		if(theme.biomes.contains(Type.NETHER))    {
			nether.add(theme);
			System.out.println("[DLDUNGEONS] Assigning theme " + theme + " to nether.");
		}
		if(theme.biomes.contains(Type.PLAINS))    {
			plains.add(theme);
			System.out.println("[DLDUNGEONS] Assigning theme " + theme + " to plains.");
		}
		if(theme.biomes.contains(Type.SWAMP))     {
			swamp.add(theme);
			System.out.println("[DLDUNGEONS] Assigning theme " + theme + " to swamp.");
		}
		if(theme.biomes.contains(Type.WASTELAND)) {
			wasteland.add(theme);
			System.out.println("[DLDUNGEONS] Assigning theme " + theme + " to wasteland.");
		}
		if(theme.biomes.contains(Type.WATER) || theme.biomes.contains(Type.BEACH)) {
			water.add(theme);  
			System.out.println("[DLDUNGEONS] Assigning theme " + theme + " to water.");  	
		}
    }
    
    
    public static Theme getTheme(BiomeGenBase biome, Random random) {
		//System.out.println("[DLDUNGEONS] Dungeon biome is " + biome + ".");
    	HashSet<Theme> set = new HashSet<Theme>();
    	ArrayList<Theme> use = new ArrayList<Theme>();
    	set.clear();
    	use.clear();
		if(BiomeDictionary.isBiomeOfType(biome, Type.DESERT)) {
			set.addAll(desert);
			//System.out.println("[DLDUNGEONS] Adding them list for desert.");
		}
		if(BiomeDictionary.isBiomeOfType(biome, Type.END)) {
			set.addAll(end);
			//System.out.println("[DLDUNGEONS] Adding them list for desert.");
		}
		if(BiomeDictionary.isBiomeOfType(biome, Type.FOREST)) {
			set.addAll(forest);
			//System.out.println("[DLDUNGEONS] Adding them list for forest.");
		}
		if(BiomeDictionary.isBiomeOfType(biome, Type.FROZEN)) {
			set.addAll(frozen);
			//System.out.println("[DLDUNGEONS] Adding them list for frozen.");
		}
		if(BiomeDictionary.isBiomeOfType(biome, Type.HILLS)) {
			set.addAll(hills);
			//System.out.println("[DLDUNGEONS] Adding them list for hills.");
		}
		if(BiomeDictionary.isBiomeOfType(biome, Type.JUNGLE)) {
			set.addAll(jungle);
			//System.out.println("[DLDUNGEONS] Adding them list for jungle.");
		}
		if(BiomeDictionary.isBiomeOfType(biome, Type.MAGICAL)) {
			set.addAll(magical);
			//System.out.println("[DLDUNGEONS] Adding them list for magical.");
		}
		if(BiomeDictionary.isBiomeOfType(biome, Type.MOUNTAIN)) {
			set.addAll(mountain);
			//System.out.println("[DLDUNGEONS] Adding them list for moutains.");
		}
		if(BiomeDictionary.isBiomeOfType(biome, Type.MUSHROOM)) {
			set.addAll(mushroom);
			//System.out.println("[DLDUNGEONS] Adding them list for mushroom.");
		}
		if(BiomeDictionary.isBiomeOfType(biome, Type.NETHER)) {
			set.addAll(nether);
			//System.out.println("[DLDUNGEONS] Adding them list for nether.");
		}
		if(BiomeDictionary.isBiomeOfType(biome, Type.PLAINS)) {
			set.addAll(plains);
			//System.out.println("[DLDUNGEONS] Adding them list for plains.");
		}
		if(BiomeDictionary.isBiomeOfType(biome, Type.SWAMP)) {
			set.addAll(swamp);
			//System.out.println("[DLDUNGEONS] Adding them list for swamp.");
		}
		if(BiomeDictionary.isBiomeOfType(biome, Type.WASTELAND)) {
			set.addAll(wasteland);
			//System.out.println("[DLDUNGEONS] Adding them list for wasteland.");
		}
		if(BiomeDictionary.isBiomeOfType(biome, Type.WATER) || 
				BiomeDictionary.isBiomeOfType(biome, Type.BEACH)) {
			set = (water);
			//System.out.println("[DLDUNGEONS] Adding them list for water.");
		}
    	if(set.isEmpty()) {
			//System.out.println("[DLDUNGEONS] Theme list is empty, using a default.");
    		if(biome == BiomeGenBase.hell) return Theme.nether;
    		if(biome == BiomeGenBase.sky) return Theme.end;
    		else return Theme.classic;
    	}
    	use.addAll(set);
    	Theme theme = use.get((random.nextInt(use.size())));
		//System.out.println("[DLDUNGEONS] Selected and returning " + theme +".");
    	return theme;    	
    }
	
}
